#include <sys/time.h>

#include "exanic.h"
#include "pcie_if.h"

uint64_t exanic_timestamp_to_counter(exanic_t *exanic, uint32_t timestamp)
{
    struct timeval tv;
    uint64_t time_tick;

    if (exanic->tick_hz == 0)
        return 0;

    /* Get current time in ExaNIC clock ticks */
    gettimeofday(&tv, NULL);
    time_tick = (uint64_t)tv.tv_sec * exanic->tick_hz +
        ((uint64_t)tv.tv_usec * exanic->tick_hz / 1000000);

    /* Round to nearest ExaNIC clock tick value that matches the timestamp */
    time_tick += (int32_t)(timestamp - time_tick);

    /* Convert to nanoseconds since epoch */
    return time_tick / exanic->tick_hz * 1000000000 +
        (time_tick % exanic->tick_hz) * 1000000000 / exanic->tick_hz;
}

uint32_t exanic_counter_to_timestamp(exanic_t *exanic, uint64_t counter)
{
    return counter / 1000000000 * exanic->tick_hz +
        (counter % 1000000000) * exanic->tick_hz / 1000000000;
}
