#include <stdint.h>

typedef uint64_t timing_t;

#define rdtscll(val) do { \
     unsigned int __a,__d; \
     asm volatile("rdtsc" : "=a" (__a), "=d" (__d)); \
     (val) = ((unsigned long)__a) | (((unsigned long)__d)<<32); \
} while(0)

#define timing_start rdtscll
#define timing_end rdtscll

#ifdef __cplusplus
extern "C" {
#endif
void timing_print(timing_t *stats, int count, int raw_counts);
void init_packet(char *data, int data_size);
#ifdef __cplusplus
}
#endif

