#ifndef COMMON_H_42AE3F39D1C3A32A0CAB782AF42F3689
#define COMMON_H_42AE3F39D1C3A32A0CAB782AF42F3689

#include <sys/socket.h>
#include <netpacket/packet.h>
#include <net/ethernet.h> /* the L2 protocols */

struct endpoint
{
    char name[16];

    /* eth */
    int sock;
    struct sockaddr_ll sll;

    /* exanic */
    exanic_t *exanic;
    exanic_rx_t *rx;
    exanic_tx_t *tx;
};


#ifdef __cplusplus
extern "C" {
#endif
    int endpoint_open(struct endpoint *e, const char *name, int rx, int tx);
    void endpoint_close(struct endpoint *e);
    int endpoint_send(struct endpoint *e, const char *buf, size_t len);
    ssize_t endpoint_recv(struct endpoint *e, char *buf, size_t len, int *iter, uint32_t *timestamp);
    inline uint32_t to_exanic_clk_adj(double adj);
    inline double from_exanic_clk_adj(uint32_t adj);

#ifdef __cplusplus
} /* closing brace for extern "C" */
#endif



#endif /* COMMON_H_42AE3F39D1C3A32A0CAB782AF42F3689 */
