#ifndef __NET_H__
#define __NET_H__

#include <netinet/ip.h>
#include <arpa/inet.h>

void exanic_Periodic_Handle(void);

struct ptpPacketType
{
    uint8_t *buf;
    uint16_t len;
    uint32_t ts_secs;
    uint32_t ts_nanos;
};

#pragma pack(1)
struct udp_datagram {
    uint16_t srcPort;
    uint16_t dstPort;
    uint16_t len;
    uint16_t checksum;
    //uint8_t *payload;
    uint8_t payload[128];
};

#pragma pack(1)
struct ip_packet {
    uint8_t byte1;
    uint8_t byte2;
    uint16_t length;
    uint16_t id;
    uint16_t flagsFrag;
    uint8_t ttl;
    uint8_t protocol;
    uint16_t hdrChecksum;
    in_addr_t srcip;
    in_addr_t dstip;
    struct udp_datagram udp;
};

#pragma pack(1)
struct etherFrameType {
    uint8_t dstmac[6];
    uint8_t srcmac[6];
    uint16_t etherType;
    struct ip_packet ip;
};
#endif      // __NET_H__
