#ifndef EXANIC_CLOCK_SYNC_COMMON_H_A1E81DE87A7B817E07A2AD5671E2FAAD
#define EXANIC_CLOCK_SYNC_COMMON_H_A1E81DE87A7B817E07A2AD5671E2FAAD

#define POLL_INTERVAL 1.0
#define PPS_POLL_INTERVAL 0.3
#define SHORT_POLL_INTERVAL 0.1
#define LOG_INTERVAL 60

enum sync_status
{
    SYNC_OK = 0,
    SYNC_FAST_POLL = 1,
    SYNC_FAILED = -1,
};

static inline uint32_t to_exanic_clk_adj(double adj)
{
    if (adj > 0)
        return EXANIC_CLK_ADJ_INC | ((uint32_t)(1 / adj) & 0xFFFFFF);
    else if (adj < 0)
        return EXANIC_CLK_ADJ_DEC | ((uint32_t)(-1 / adj) & 0xFFFFFF);
    else
        return 0;
}

static inline double from_exanic_clk_adj(uint32_t adj)
{
    if ((adj & EXANIC_CLK_ADJ_MASK) == 0)
        return 0;
    else if ((adj & EXANIC_CLK_ADJ_INC) != 0)
        return 1.0 / (adj & EXANIC_CLK_ADJ_MASK);
    else
        return -1.0 / (adj & EXANIC_CLK_ADJ_MASK);
}

void log_printf(int priority, const char *fmt, ...);

#endif /* EXANIC_CLOCK_SYNC_COMMON_H_A1E81DE87A7B817E07A2AD5671E2FAAD */
